%
% Keeping epsilon fixed, test the iteration needed for different lambda
% values.
%


% Clear workspace and load the functions and region
clear
addpath('..');
GivenEnv;

% * epsilon: e = 0.001
% * lambda:  l > 2e = 0.001
% * dl: A small step away from 2e
%       dl = 0.0001
% * lambda_max: 0.1
% * N: 50 points

N = 50;
epsilon = 0.001;
dl = 0.0001;
lambda_max= 0.1;
lambda = linspace(2*epsilon + dl, lambda_max, N);
k = zeros(1, N); % preallocate k


%
% * Call the bisection method for each lambda value for each function and
%   keep the number of iterations needed.
% * Plot the iterations k(lambda) for each function
%

for i = 1:length(funs)
    for j = 1:N
        [a, b, k(j)] = bisection(funs{i}, a_0, b_0, epsilon, lambda(j));
    end
    subplot(1, length(funs), i)
    plot(lambda, k, '-b', 'LineWidth', 1.0)
    title(titles(i), 'Interpreter', 'latex')
    xlabel('lambda')
    ylabel('Iterations')
end

  